<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__csd" kind="group">
    <compoundname>group_csd</compoundname>
    <title>CSD          (CapSense Sigma Delta)</title>
    <innergroup refid="group__group__csd__macros">Macros</innergroup>
    <innergroup refid="group__group__csd__functions">Functions</innergroup>
    <innergroup refid="group__group__csd__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__csd__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The CSD HW block enables multiple sensing capabilities on PSoC devices, including self-cap and mutual-cap capacitive touch sensing solutions, a 10-bit ADC, IDAC, and Comparator. </para>    </briefdescription>
    <detaileddescription>
<para>The CapSense solution includes:<itemizedlist>
<listitem><para>The CapSense Configurator tool, which is a configuration wizard to create and configure CapSense widgets. It can be launched in ModusToolbox from the CSD personality as well as in standalone mode. It contains separate documentation on how to create and configure widgets, parameters, and algorithm descriptions.</para></listitem><listitem><para>An API to control the design from the application program. This documentation describes the API with code snippets about how to use them.</para></listitem><listitem><para>The CapSense Tuner tool for real-time tuning, testing, and debugging, for easy and smooth design of human interfaces on customer products. The Tuner tool communicates with a device through a HW bridge and communication drivers (EzI2C, UART, etc.) and allows monitoring of widget statuses, sensor signals, detected touch positions, gestures, etc. The application program does not need to interact with the CSD driver and/or other drivers such as GPIO or SysClk directly. All of that is configured and managed by middleware.</para></listitem></itemizedlist>
</para><para><image name="capsense_solution.png" type="html" width="800px">CapSense Solution</image>
 
</para><para>This section describes only the CSD driver. Refer to the corresponding sections for documentation of middleware supported by the CSD HW block.</para><para>The CSD driver is a low-level peripheral driver that provides an interface to a complex mixed signal of the CSD HW block.</para><para>The CSD driver alone does not provide system-level functions. Instead, it is used by upper-level middleware to configure the CSD HW block required by an application.</para><para>The CSD HW block can support only one function at a time. To allow seamless time-multiplex implementation of functionality and to avoid conflicting access to hardware from the upper level, the CSD driver also implements a lock semaphore mechanism.</para><para>The CSD driver supports re-entrance. If a device contains several CSD HW blocks, the same CSD driver is used to configure any HW block. For that, each function of the CSD driver contains a base address to define the CSD HW block to which the CSD driver communicates.</para><para>For dual-core devices, the CSD driver functions can be called either by the CM0+ or CM4 cores. In case both cores need access to the CSD Driver, you should properly manage the memory access.</para><para>There is no restriction on the CSD Driver usage in RTOS.</para>
<para><heading level="1">Usage</heading></para>
<para>The CSD driver is simple wrapper driver specifically designed to be used by higher level middleware. Hence, is highly not recommended to use CSD driver directly in the application program. To incorporate CSD HW block functionality in the application program, an associated middleware should be used.</para><para>The CSD Driver can be used to implement a custom sensing solution. In such a case, the application program must acquire and lock the CSD HW block prior to accessing it.</para><para>Setting up and using the CSD driver can be summed up in these four stages:<itemizedlist>
<listitem><para>Define configuration in the config structure.</para></listitem><listitem><para>Allocate context structure variable for the driver.</para></listitem><listitem><para>Capture the CSD HW block.</para></listitem><listitem><para>Execute the action required to perform any kind of conversion.</para></listitem></itemizedlist>
</para><para>The following code snippet demonstrates how to capture the CSD HW block for custom implementation:</para><para><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Scenario:<sp />Need<sp />to<sp />perform<sp />a<sp />conversion.<sp />It<sp />is<sp />supposed<sp />that<sp />Pins,<sp />Clock,<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*<sp />Interrupt,<sp />pre-charge<sp />and<sp />scanning<sp />configs<sp />are<sp />already<sp />prepared.</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csd__enums_1ga281a1b4a5cddb0bee365a7835985ccba">cy_en_csd_key_t</ref><sp />key;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csd__enums_1ga6cde526987c66fff895f48902589f979">cy_en_csd_status_t</ref><sp />status;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Allocate<sp />CSD<sp />configuration<sp />structure<sp />and<sp />initialize<sp />it<sp />with<sp />user's<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__csd__config__t">cy_stc_csd_config_t</ref><sp />customConfig<sp />=<sp />PRECHARGE_CONFIG;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />if<sp />the<sp />CSD<sp />block<sp />if<sp />free<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />key<sp />=<sp /><ref kindref="member" refid="group__group__csd__functions_1gafc4c25c2faefdfb3f3fdcf070b645c13">Cy_CSD_GetLockStatus</ref>(CSD0,<sp />&amp;csdContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csd__enums_1gga281a1b4a5cddb0bee365a7835985ccbaa6ecb94eb2fc43363fdeb79fa9dd965b2">CY_CSD_NONE_KEY</ref><sp />==<sp />key)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Capture<sp />the<sp />CSD<sp />block<sp />and<sp />initialize<sp />it<sp />with<sp />user's<sp />configuration<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />status<sp />=<sp /><ref kindref="member" refid="group__group__csd__functions_1ga22ab53f2e99efe2990b5c99c06dc0be7">Cy_CSD_Init</ref>(CSD0,<sp />&amp;customConfig,<sp /><ref kindref="member" refid="group__group__csd__enums_1gga281a1b4a5cddb0bee365a7835985ccbaaa7ed46ced5551442fae3aaf0ea142686">CY_CSD_USER_DEFINED_KEY</ref>,<sp />&amp;csdContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />if<sp />the<sp />CSD<sp />block<sp />was<sp />captured<sp />successfully<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__csd__enums_1gga6cde526987c66fff895f48902589f979a0c2b57b4095e1c232b5c41eab3298098">CY_CSD_SUCCESS</ref><sp />==<sp />status)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Block<sp />is<sp />captured<sp />successfully.<sp />User's<sp />application<sp />code<sp />can<sp />be<sp />placed<sp />and<sp />executed<sp />here.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*...*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting> The entire solution, either CapSense or CSDADC, in addition to the CSD HW block, incorporates the following instances:</para><para><itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__csd_1group_csd_config_clocks">Clocks</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__csd_1group_csd_config_refgen">Reference Voltage Input</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__csd_1group_csd_config_interrupts">Interrupts</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__csd_1group_csd_config_pin">GPIO Pins</ref></para></listitem></itemizedlist>
</para><para>The CSD driver does not configure those blocks and they should be managed by an upper level. When using CapSense or CSDADC, those blocks are managed by middleware.</para>
<para><bold>Clocks</bold></para>
<para>The CSD HW block requires a peripheral clock (clk_peri) input. It can be assigned using two methods:<itemizedlist>
<listitem><para>Using the Device Configurator (Peripheral-Clocks tab ).</para></listitem><listitem><para>Using the SysClk (System Clock) driver. Refer to <ref kindref="compound" refid="group__group__sysclk">SysClk (System Clock)</ref> driver section for more details. If middleware is used, the clock is managed by middleware.</para></listitem></itemizedlist>
</para>

<para><bold>GPIO Pins</bold></para>
<para>Any analog-capable GPIO pin that can be connected to an analog multiplexed bus (AMUXBUS) can be connected to the CSD HW block as an input.</para><para>GPIO input can be assigned to the CSD HW block using the following methods:<itemizedlist>
<listitem><para>Using the Device Configurator (Pins tab).</para></listitem><listitem><para>Using the GPIO (General Purpose Input Output) driver. Refer to <ref kindref="compound" refid="group__group__gpio">GPIO (General Purpose Input Output)</ref> driver section.</para></listitem></itemizedlist>
</para><para>If middleware is used, pin configuration is managed by middleware. When using the CSD driver for custom implementation, the application program must manage pin connections.</para><para>Each AMUXBUS can be split into multiple segments. Ensure the CSD HW block and a GPIO belong to the same bus segment or join the segments to establish connection of the GPIO to the CSD HW block.</para><para>For more information about pin configuration, refer to the <ref kindref="compound" refid="group__group__gpio">GPIO (General Purpose Input Output)</ref> driver.</para>

<para><bold>Reference Voltage Input</bold></para>
<para>The CSD HW block requires a reference voltage input to generate programmable reference voltage within the CSD HW block. There are two on-chip reference sources:<itemizedlist>
<listitem><para>VREF</para></listitem><listitem><para>AREF</para></listitem></itemizedlist>
</para><para>For more information about specification and startup of reference voltage sources, refer to the <ref kindref="compound" refid="group__group__sysanalog">SysAnalog (System Analog Reference Block)</ref> driver prior to making the selection.</para>

<para><bold>Interrupts</bold></para>
<para>The CSD HW block has one interrupt that can be assigned to either the Cortex M4 or Cortex M0+ core. The CSD HW block can generate interrupts on the following events:</para><para><itemizedlist>
<listitem><para>End of sample: when scanning of a single sensor is complete.</para></listitem><listitem><para>End of initialization: when initialization of an analog circuit is complete.</para></listitem><listitem><para>End of measurement: when conversion of an CSDADC channel is complete.</para></listitem></itemizedlist>
</para><para>Additionally, the CSD interrupt can wake the device from the Sleep power mode. The CSD HW block is powered down in the Deep Sleep or Hibernate power modes. So, it cannot be used as a wake-up source in these power modes.</para><para>If a CapSense or ADC middleware is used, the interrupt service routine is managed by middleware. When using the CSD driver for custom implementation or other middleware, the application program must manage the interrupt service routine.</para><para>Implement an interrupt routine and assign it to the CSD interrupt. Use the pre-defined enumeration as the interrupt source of the CSD HW block. The CSD interrupt to the NVIC is raised any time the intersection (logic AND) of the interrupt flags and the corresponding interrupt masks are non-zero. The peripheral interrupt status register should be read in the ISR to detect which condition generated the interrupt. The appropriate interrupt registers should be cleared so that subsequent interrupts can be handled.</para><para>The following code snippet demonstrates how to implement a routine to handle the interrupt. The routine is called when a CSD interrupt is triggered.</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />snippet_Cy_CSD_IntHandler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />intrStatus;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />interrupt<sp />status<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />intrStatus<sp />=<sp /><ref kindref="member" refid="group__group__csd__functions_1ga34f48f5162adea39ed451877893a1552">Cy_CSD_ReadReg</ref>(CSD0,<sp /><ref kindref="member" refid="group__group__csd__reg__const_1ga6acd77ce405ea93b0d14b08a9f52e117">CY_CSD_REG_OFFSET_INTR</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />an<sp />event<sp />that<sp />triggered<sp />the<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />((intrStatus<sp />&amp;<sp />CSD_INTR_SET_SAMPLE_Msk)<sp />==<sp />CSD_INTR_SET_SAMPLE_Msk)</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />End<sp />of<sp />scan<sp />occurred,<sp />get<sp />the<sp />result<sp />and<sp />do<sp />something<sp />with<sp />it<sp />here<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clear<sp />pending<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csd__functions_1ga3689a475c33996ff4cb5e8c24d1194c1">Cy_CSD_WriteReg</ref>(CSD0,<sp /><ref kindref="member" refid="group__group__csd__reg__const_1ga6acd77ce405ea93b0d14b08a9f52e117">CY_CSD_REG_OFFSET_INTR</ref>,<sp />intrStatus);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__csd__functions_1ga34f48f5162adea39ed451877893a1552">Cy_CSD_ReadReg</ref>(CSD0,<sp /><ref kindref="member" refid="group__group__csd__reg__const_1ga6acd77ce405ea93b0d14b08a9f52e117">CY_CSD_REG_OFFSET_INTR</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting> The following code snippet demonstrates how to configure and enable the CSD interrupt:</para><para><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />CSD0_ISR_cfg<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />(CY_IP_M4CPUSS_VERSION<sp />==<sp />1)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref><sp />=<sp />NvicMux8_IRQn,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />interrupt<sp />is<sp />NVIC<sp />#8<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />NvicMux7_IRQn,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />CM0+<sp />interrupt<sp />is<sp />NVIC<sp />#7<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.cm0pSrc<sp />=<sp />csd_interrupt_IRQn,<sp /><sp /></highlight><highlight class="comment">/*<sp />Source<sp />of<sp />NVIC<sp />#8<sp />is<sp />the<sp />CSD<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />3u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />priority<sp />is<sp />3<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrSrc<sp />=<sp />csd_interrupt_IRQn,<sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />source<sp />is<sp />the<sp />CSD<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.intrPriority<sp />=<sp />3u,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Interrupt<sp />priority<sp />is<sp />3<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configure<sp />the<sp />interrupt<sp />with<sp />vector<sp />at<sp />snippet_Cy_CSD_IntHandler()<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;CSD0_ISR_cfg,<sp />snippet_Cy_CSD_IntHandler);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_EnableIRQ(CSD0_ISR_cfg.<ref kindref="member" refid="structcy__stc__sysint__t_1a6da08d81da65a7f93d3e4c46a4b8d950">intrSrc</ref>);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />the<sp />CSD<sp />SAMPLE<sp />interrupt<sp />mask<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__csd__functions_1ga3689a475c33996ff4cb5e8c24d1194c1">Cy_CSD_WriteReg</ref>(CSD0,<sp /><ref kindref="member" refid="group__group__csd__reg__const_1ga4d672ab537cfdd238ed7cb340dca26e3">CY_CSD_REG_OFFSET_INTR_MASK</ref>,<sp />CSD_INTR_MASK_SAMPLE_Msk);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting> For more information, refer to the <ref kindref="compound" refid="group__group__sysint">SysInt (System Interrupt)</ref> driver.</para><para>Alternatively, instead of handling the interrupts, the <ref kindref="member" refid="group__group__csd__functions_1gab3e991dec9a467c332da3f904bdf5acc">Cy_CSD_GetConversionStatus()</ref> function allows for firmware polling of the CSD block status.</para>


<para><heading level="1">Power Modes</heading></para>
<para>The CSD HW block can operate in Active and Sleep CPU power modes. It is also possible to switch between Low power and Ultra Low power system modes. In Deep Sleep and in Hibernate power modes, the CSD HW block is powered off. When the device wakes up from Deep Sleep, the CSD HW block resumes operation without the need for re-initialization. In the case of wake up from Hibernate power mode, the CSD HW block does not retain configuration and it requires re-initialization.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;The CSD driver does not provide a callback function to facilitate the low-power mode transitions. The responsibility belongs to an upper level that uses the CSD HW block to ensure the CSD HW block is not busy prior to a power mode transition.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;A power mode transition is not recommended while the CSD HW block is busy. The CSD HW block status must be checked using the Cy_CSD_GetStatus() function prior to a power mode transition. Instead, use the same power mode for active operation of the CSD HW block. This restriction is not applicable to Sleep mode and the device can seamlessly enter and exit Sleep mode while the CSD HW block is busy.&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;&lt;ol&gt;&lt;li&gt;&lt;p&gt;Do not enter Deep Sleep power mode if the CSD HW block conversion is in progress. Unexpected behavior may occur.&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;Analog start up time for the CSD HW block is 25 us. Initiate any kind of conversion only after 25 us from Deep Sleep / Hibernate exit.&lt;/p&gt;&lt;/li&gt;&lt;/ol&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Refer to the </verbatim><ref kindref="compound" refid="group__group__syspm">SysPm (System Power Management)</ref> driver for more information about low-power mode transitions.</para>

<para><heading level="1">More Information</heading></para>
<para>For more information, refer to the following documents:</para><para><itemizedlist>
<listitem><para><ulink url="http://www.cypress.com/trm218176">Technical Reference Manual (TRM)</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/capsense">Cypress CapSense Middleware Library</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/capsense/capsense_api_reference_manual/html/index.html">Cypress CapSense Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/csdadc">Cypress CSDADC Middleware Library</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/csdadc/csdadc_api_reference_manual/html/index.html">Cypress CSDADC Middleware API Reference Guide</ulink></para></listitem><listitem><para><ulink url="https://github.com/cypresssemiconductorco/csdidac">Cypress CSDIDAC Middleware Library</ulink></para></listitem><listitem><para><ulink url="https://cypresssemiconductorco.github.io/csdidac/csdidac_api_reference_manual/html/index.html">Cypress CSDIDAC Middleware API Reference Guide</ulink></para></listitem><listitem><para><ref kindref="compound" refid="page_getting_started">Getting Started with the PDL</ref></para></listitem><listitem><para><ulink url="http://www.cypress.com/ds218787">PSoC 63 with BLE Datasheet Programmable System-on-Chip</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/an85951">AN85951 PSoC 4 and PSoC 6 MCU CapSense Design Guide for more detail</ulink></para></listitem><listitem><para><ulink url="http://www.cypress.com/an210781">AN210781 Getting Started with PSoC 6 MCU with Bluetooth Low Energy (BLE) Connectivity</ulink></para></listitem></itemizedlist>
</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;14.2 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;All non-null statements shall either: a) have at least one side-effect however executed, or b) cause control flow to change. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The unused function parameters are cast to void. This statement has no side effect and is used to suppress a compiler warning.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;20.6 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The macro offsetof, in library &amp;lt;stddef.h&amp;gt;, shall not be used. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The only CSD HW block register offsets are defined using this macro to implement functions Read/WriteReg.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The CSD driver sources are enclosed with the conditional compilation to ensure a successful compilation for non-CapSense-capable devices  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Compilation for non-CapSense-capable devices &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Changed the &lt;a href="group__group__csd__functions.html#group__group__csd__functions_1gab3e991dec9a467c332da3f904bdf5acc"&gt;Cy_CSD_GetConversionStatus()&lt;/a&gt; function implementation &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixed defect   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation updates &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improve user's experience  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>